"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var body_parser_1 = require("body-parser");
var express_1 = require("express");
var countEntities_1 = require("./functions/countEntities");
var createEntity_1 = require("./functions/createEntity");
var getEntities_1 = require("./functions/getEntities");
var getEntity_1 = require("./functions/getEntity");
var patchEntities_1 = require("./functions/patchEntities");
var removeEntities_1 = require("./functions/removeEntities");
var removeEntity_1 = require("./functions/removeEntity");
var replaceEntity_1 = require("./functions/replaceEntity");
var handleTransaction_1 = require("./utils/handleTransaction");
exports.default = (function (factoryConfig) {
    var facadeConfig = __assign({ constructFilter: function (_a) {
            var filter = _a.filter;
            return filter;
        }, defaultPaginationLimit: 10, handleTransaction: handleTransaction_1.default }, factoryConfig);
    var router = express_1.Router();
    router.use(body_parser_1.json());
    router.get('/count', countEntities_1.default(facadeConfig));
    router.delete('/:id', removeEntity_1.default(facadeConfig));
    router.get('/:id', getEntity_1.default(facadeConfig));
    router.patch('/:id', patchEntities_1.default(facadeConfig));
    router.put('/:id', replaceEntity_1.default(facadeConfig));
    router.delete('', removeEntities_1.default(facadeConfig));
    router.get('', getEntities_1.default(facadeConfig));
    router.post('', createEntity_1.default(facadeConfig));
    return router;
});
//# sourceMappingURL=factory.js.map