"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var NumberError_1 = require("./NumberError");
exports.default = (function (query, paramName, defaultValue) {
    var paramValue = query[paramName];
    if (paramValue === undefined) {
        return defaultValue;
    }
    var parsedParamValue = Number(paramValue);
    if (isNaN(parsedParamValue)) {
        throw new NumberError_1.default(paramValue, [paramName]);
    }
    return parsedParamValue;
});
//# sourceMappingURL=getNumberQueryParam.js.map