"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ConflictingEntityError_1 = require("@js-entity-repos/core/dist/errors/ConflictingEntityError");
var MissingEntityError_1 = require("@js-entity-repos/core/dist/errors/MissingEntityError");
var http_status_codes_1 = require("http-status-codes");
var JsonError_1 = require("./JsonError");
var NumberError_1 = require("./NumberError");
var handleError = function (_a) {
    var res = _a.res, err = _a.err, transactionId = _a.transactionId;
    var sendErrorResponse = function (statusCode, errorData) {
        var body = __assign({}, errorData, { transactionId: transactionId });
        res.status(statusCode).json(body);
    };
    if (err instanceof ConflictingEntityError_1.default) {
        sendErrorResponse(http_status_codes_1.CONFLICT, {
            entityId: err.entityId,
            entityName: err.entityName,
        });
        return;
    }
    if (err instanceof MissingEntityError_1.default) {
        sendErrorResponse(http_status_codes_1.NOT_FOUND, {
            entityId: err.entityId,
            entityName: err.entityName,
        });
        return;
    }
    if (err instanceof JsonError_1.default) {
        sendErrorResponse(http_status_codes_1.BAD_REQUEST, {
            data: err.data,
            path: err.path,
        });
        return;
    }
    if (err instanceof NumberError_1.default) {
        sendErrorResponse(http_status_codes_1.BAD_REQUEST, {
            data: err.data,
            path: err.path,
        });
        return;
    }
    /* istanbul ignore next */
    {
        sendErrorResponse(http_status_codes_1.INTERNAL_SERVER_ERROR, {});
        return;
    }
};
exports.default = handleError;
//# sourceMappingURL=handleError.js.map